
package Tangram::Lazy::BackRef;

use vars qw(@ISA);
 @ISA = qw( Tangram::Lazy::Ref );

sub TIESCALAR
{
   my $pkg = shift;
   return bless [ @_ ], $pkg;
}

sub FETCH
{
	my $self = shift;
	my ($storage, $id, $member, $refid, $class, $field) = @$self;
	my $obj = $storage->{objects}{$id};

	my $owner = $storage->remote($class);
        my $refobj;

        # you had better hope the other side of this is indexed
        # only ever returns the first matching one
        # pretty sure that doesn't make sense and it should always return an array
        # and it's up to the caller to work it out

        if (exists $storage->{schema}->{classes}->{$class}->{fields}->{array}->{$field}) {
          # this was original includes, not eq, so it was written for collections
          # that makes sense where $owner->{$field} has type array
	  ($refobj) = $storage->select($owner, $owner->{$field}->includes($obj));
        } 
        else { # plain ref
          ($refobj) = $storage->select($owner, ($owner->{$field} eq $obj));
        }


#	my $refobj = $storage->load($refid);

	untie $obj->{$member};
	$obj->{$member} = $refobj;	# weak
	return $refobj;
}

1;
